Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Index.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Index.cshtml	(revision 13844)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Index.cshtml	(revision 13847)
@@ -7,5 +7,5 @@
 <div>
     <!-- Main nav menu-->
-    @Html.Partial("Navbar", new NavbarViewModel("Job"))
+    @Html.Partial("Navbar", new NavbarViewModel("Job", Model.currentUser))
 
     <!-- Job menu-->
@@ -27,8 +27,5 @@
     </ul>
 
-    <div class="row"
-         style="text-align:center">
-        @Model.message
-    </div>
+    @Html.Partial("_ErrorMessage", Model.message)
 
     <div class="row"
@@ -52,5 +49,5 @@
                         <i class="fa fa-cog"></i> Hive jobs
                     </a>
-                    @foreach (var job in Model.userJobs)
+                    @foreach (var job in Model.userJobs.OrderBy(x => x.Job.DateCreated))
                 {
                         <a class="btn btn-default
@@ -64,5 +61,6 @@
                            onclick="showLoader()">
                             @job.Job.Name - @job.Job.DateCreated
-                            <span class="label
+                            <span style="text-shadow:2px 2px black; font-size:13px"
+                                  class="label
                                    @(job.Job.FinishedCount == @job.Job.JobCount ? "label-success" : "label-default")
                                    label-as-badge pull-right">
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFile.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFile.cshtml	(revision 13844)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFile.cshtml	(revision 13847)
@@ -14,5 +14,5 @@
     <div id="userId" style="display:none">@ViewBag.SessionId</div>
     <!-- Main nav menu -->
-    @Html.Partial("Navbar", new HeuristicLab.Clients.Hive.WebJobManager.ViewModels.NavbarViewModel("Job"))
+    @Html.Partial("Navbar", new HeuristicLab.Clients.Hive.WebJobManager.ViewModels.NavbarViewModel("Job", Model.currentUser))
 
     <!-- Job menu-->
@@ -42,7 +42,7 @@
         </a>
     </div>
-    @Html.Partial("OpenFilePartials/_Help", Model);
+    @Html.Partial("OpenFilePartials/_Help", Model)
     <!-- Check model to select right partial, partial handles all subloading -->
-    <div class="col-md-9">
+    <div class="col-sm-9">
         @if (Model.SelectedAlgorithm != null)
         {
@@ -170,24 +170,52 @@
                       asp-action="saveToFile"
                       method="post">
-                    <div class="col-sm-6"
-                         style="text-align:right">
-                        <h5>File name</h5>
-                    </div>
-                    <div class="col-sm-6"
-                         style="text-align:left">
-                        <div class="form-group">
-                            <div class="input-group">
-                                <input type="text"
-                                       class="form-control"
-                                       name="fname"
-                                       id="fname"
-                                       required
-                                       placeholder="File name">
+                    <div class="row">
+                        <div class="col-sm-3"
+                             style="text-align:right">
+                            <h5>File name</h5>
+                        </div>
+                        <div class="col-sm-9"
+                             style="text-align:left">
+                            <div class="form-group">
+                                <div class="input-group">
+                                    <input type="text"
+                                           class="form-control"
+                                           name="fname"
+                                           id="fname"
+                                           required
+                                           placeholder="File name">
+                                </div>
                             </div>
                         </div>
                     </div>
-                    <div class="row"
-                         style="text-align:center">
-                        <h5>Directory: /HiveChanged</h5>
+                    <div class="row">
+                        <div class="col-sm-3"
+                             style="text-align:right">
+                            <h5>Directory name</h5>
+                        </div>
+                        <div class="col-sm-9"
+                             style="text-align:left">
+                            <div class="form-group">
+                                <div class="input-group">
+                                    <input type="text"
+                                           class="form-control"
+                                           name="dname"
+                                           id="dname"
+                                           required
+                                           placeholder="Directory name"
+                                           list="dirnames">
+                                </div>
+                                <datalist id="dirnames">
+                                    @if (!Model.directories.Contains(DateTime.Now.ToString("yyyy.MM.dd")))
+                                    {
+                                        <option value="@(DateTime.Now.ToString("yyyy.MM.dd"))">Creates new directory for today</option>
+                                    }
+                                    @foreach (var d in Model.directories)
+                                    {
+                                        <option value="@d"></option>
+                                    }
+                                </datalist>
+                            </div>
+                        </div>
                     </div>
                     <button class="btn btn-success btn-block" type="submit"
@@ -203,6 +231,7 @@
     </div>
     <!-- Side scrolling menu-->
-    <nav class="col-md-2" id="scrolly">
+    <nav class="col-sm-2" id="scrolly">
         <ul class="nav nav-pills nav-stacked"
+            style="position:fixed"
             data-spy="affix"
             data-offset-top="0">
@@ -222,5 +251,5 @@
             }
             <li><a href="#finish"><i class="fa fa-flag-checkered"></i> Add to Hive or save to file</a></li>
-            <li>
+            <li style="position:fixed">
                 <div class="alert alert-success" id="success-alert">
                     <span id="succText"></span>
@@ -262,9 +291,10 @@
         });
         collapser = function () {
-            $('.collapse').collapse('hide');
+            $('.collapse').not('#helperCol').collapse('hide');
             //closes every collapse
         }
         shower = function () {
-            $('.collapse').collapse('show');
+            $('.collapse').not('#helperCol').collapse('show');
+            
             //opens every collapse
         }
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_Help.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_Help.cshtml	(revision 13844)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_Help.cshtml	(revision 13847)
@@ -17,5 +17,5 @@
     <div class="collapse row" 
          id="helperCol"
-         style="background-color:#5bc0de;color:black; font-size:larger; box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+         style="background-color:#5bc0de;color:black; box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
                             ">
         <h3>Types</h3>
@@ -23,7 +23,5 @@
         <span class="label label-primary">Algorithm</span>. Clicking the buttons will expand them and show more information.</p> 
         <h3>Parameters</h3>
-        <p>All parameter changes happen in real time as soon as you change them. Pop ups will appear if your attention is needed for a specific part.</p>
-        <p style="font-style:italic; font-weight:bold">When you change a parameter from a task that falls under any repitition, the changes are pushed to all the other tasks too.
-        The interface only shows the change for one task.</p>
+        <p>All parameter changes happen in real time as soon as you change them. A log on the right menu will keep you updated.</p>
         <h3>Hive</h3>
         <p>This screen acts as a staging area. When you have changed all the data to your wishes you can go to the bottom of the screen to
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/UploaderPartial/_UploaderPartial.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/UploaderPartial/_UploaderPartial.cshtml	(revision 13844)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/UploaderPartial/_UploaderPartial.cshtml	(revision 13847)
@@ -1,3 +1,5 @@
-﻿
+﻿@model HeuristicLab.Clients.Hive.WebJobManager.ViewModels.UploadedJobViewModel
+
+
 <div class="panel panel-default"
      style="border-width:2px!important;padding:17px;
@@ -5,68 +7,76 @@
 
 
-        <form method="post"
-               asp-action="Uploader"
-               asp-controller="Job" enctype="multipart/form-data">
-             <input onchange="printFiles()"
-                    type="file"
-                    id="files"
-                    name="files"
-                    multiple accept=".hl"
-                    style="display:none" />
+    <form method="post"
+          asp-action="Uploader"
+          asp-controller="Job" enctype="multipart/form-data">
+        <input onchange="printFiles()"
+               type="file"
+               id="files"
+               name="files"
+               multiple accept=".hl"
+               style="display:none" />
 
-             <div onclick="firefilebutton()"
-                  class="btn btn-info btn-lg btn-block"
-                  style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+        <div onclick="firefilebutton()"
+             class="btn btn-info btn-lg btn-block"
+             style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
                                  text-shadow:1px 1px black;">
-                 <i class="fa fa-folder-open-o"></i> Choose file(s) to upload to the server
-             </div>
+            <i class="fa fa-folder-open-o"></i> Choose file(s) to upload to the server
+        </div>
 
-             <div class="row" style="margin:10px">
+        <div class="row" style="margin:10px">
 
-                 <div id="selectedfiles">
-                 <h3>Files</h3>
-                 <p>No files selected: press the above button to choose files</p>
-                 </div>
+            <div id="selectedfiles">
+                <h3>Files</h3>
+                <p>No files selected: press the above button to choose files</p>
+            </div>
 
-                 <button style="margin-bottom:10px; box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+            <button style="margin-bottom:10px; box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
                                  text-shadow:2px 2px black;"
-                      type="button"
-                         disabled
-                      id="del"
-                      class='btn btn-danger'
-                      onclick='deletefiles()'>
-                     <span class='glyphicon glyphicon-trash' aria-hidden='true'></span>
-                     Remove files
-                 </button>
+                    type="button"
+                    disabled
+                    id="del"
+                    class='btn btn-danger'
+                    onclick='deletefiles()'>
+                <span class='glyphicon glyphicon-trash' aria-hidden='true'></span>
+                Remove files
+            </button>
 
-                 <div
-                      style="margin-top:20px;margin-bottom:20px">
+            <div style="margin-top:20px;margin-bottom:20px">
 
-                     <label for="basic-url">Directory name</label>
-                     <div class="input-group">
-                         <span class="input-group-addon"
-                               id="basic-addon3">
-                             .../uploads/@ViewBag.Name
-                         </span>
-                         <input
-                                type="text"
-                                disabled
-                                class="form-control"
-                                id="directory"
-                                name="directory"
-                                aria-describedby="basic-addon3"
-                                value="@(DateTime.Now.ToString("yyyy.MM.dd"))" />
-                     </div>
-                 </div>
-                 <button style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+                <label for="basic-url">Directory name</label>
+                <div class="input-group">
+                    <span class="input-group-addon"
+                          id="basic-addon3">
+                        .../uploads/@(Model.currentUser.currentUser.UserName != null ?  Model.currentUser.currentUser.UserName : Model.currentUser.currentUser.FullName)/
+                    </span>
+                    <input type="text"
+                           disabled
+                           class="form-control"
+                           id="directory"
+                           name="directory"
+                           aria-describedby="basic-addon3"
+                           
+                           list="dirnames"/>
+                    <datalist id="dirnames">
+                        @if (!Model.DisplayDatePaths.Contains(DateTime.Now.ToString("yyyy.MM.dd")))
+                        {
+                            <option value="@(DateTime.Now.ToString("yyyy.MM.dd"))">Creates new map for today</option>
+                        }    
+                        @foreach(var d in Model.DisplayDatePaths)
+                        {
+                            <option value="@d"></option>
+                        }
+                    </datalist>
+                </div>
+            </div>
+            <button style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
                                  text-shadow:2px 2px black;"
-                        disabled
-                         id="upl"
-                        class="btn btn-lg btn-block btn-success"
-                        type="submit"
-                         >
-                     <i class="fa fa-plus-square"></i> Add to uploads
-                     </button>
-             </div>
+                    disabled
+                    id="upl"
+                    class="btn btn-lg btn-block btn-success"
+                    type="submit">
+                <i class="fa fa-plus-square"></i> Add to uploads
+            </button>
+        </div>
 
     </form>
@@ -83,5 +93,5 @@
             document.getElementById("directory").disabled = false;
 
-            
+
             for (var i = 0; i < files.length; i++) {
                 div.innerHTML += "<p>File " + (i + 1) + ":" + files[i].name +
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Uploads.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Uploads.cshtml	(revision 13844)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Uploads.cshtml	(revision 13847)
@@ -5,5 +5,5 @@
 <div>
 
-    @Html.Partial("Navbar", new HeuristicLab.Clients.Hive.WebJobManager.ViewModels.NavbarViewModel("Job"))
+    @Html.Partial("Navbar", new HeuristicLab.Clients.Hive.WebJobManager.ViewModels.NavbarViewModel("Job", Model.currentUser))
 
     <ul class="nav nav-pills nav-justified">
@@ -23,154 +23,162 @@
         </li>
     </ul>
-    <div class="row" style="margin:10px">
-        <div style="text-align:center">@Model.message</div>
-
-    </div>
+    
+    @Html.Partial("_ErrorMessage", Model.message)
+
     <div class="row" style="padding:10px">
-        @if (Model.DisplayDatePaths.Count == 0)
-        {
-            <div>
-                <p style="text-align:center">
-                    No files uploaded
-                </p>
-                <a class="btn btn-success btn-lg btn-block"
+        <div class="col-sm-4">
+            <div class="btn-group btn-group-justified btn-block"
+                 role="group" style="margin-bottom:-4px">
+
+                <a class="btn btn-info btn-lg btn-block disabled"
+                   style="width:6%; box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+                            text-shadow:2px 2px black;">
+                    <i class="fa fa-cloud"></i> Uploads
+                </a>
+                <a class="btn btn-success btn-block
+                       @(Model.SelectedIndex == -1 ? "active" : "")
+                       "
                    asp-controller="Job"
-                   asp-action="Uploader"
-                   style="margin:10px; box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+                   asp-action="UploadDir"
+                   asp-route-index="-1"
+                   onclick="showUploader()"
+                   style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
                             text-shadow:2px 2px black;">
-                    <i class="fa fa-cloud-upload"></i> Upload new file(s)
+                    <i class="fa fa-cloud-upload"></i>
                 </a>
             </div>
-
-        }
-        else {
-            <div class="col-sm-4">
-                <div class="btn-group btn-group-justified btn-block"
-                     role="group" style="margin-bottom:-4px">
-
-                    <a class="btn btn-info btn-lg btn-block disabled"
-                       style="width:6%; box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
-                            text-shadow:2px 2px black;">
-                        <i class="fa fa-cloud"></i> Uploads
-                    </a>
-                    <a class="btn btn-success btn-block
-                       @(Model.SelectedIndex == -1 ? "active" : "")
-                       "
+            <div class="btn-group-vertical btn-block">
+
+                @for (int i = 0; i < Model.DisplayDatePaths.Count; i++)
+                {
+                    <a class="btn  btn-default @(i == Model.SelectedIndex ? "active" : "" )"
+                       style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);"
                        asp-controller="Job"
                        asp-action="UploadDir"
-                       asp-route-index="-1"
-                       onclick="showUploader()"
+                       asp-route-index="@(i)"
+                       onclick="showDownloader()">
+                        @Model.DisplayDatePaths[i]
+                    </a>
+                }
+            </div>
+            @if (ViewBag.active != null && ViewBag.active == true)
+            {
+                <div>
+                    <a class="btn btn-warning btn-block"
+                       asp-controller="Job"
+                       asp-action="OpenRecent"
                        style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
-                            text-shadow:2px 2px black;">
-                        <i class="fa fa-cloud-upload"></i> 
+                            text-shadow:2px 2px black;margin-top:10px">
+                        <i class="fa fa-undo"></i> Reopen last file
                     </a>
                 </div>
-                <div class="btn-group-vertical btn-block">
-                    
-                    @for (int i = 0; i < Model.DisplayDatePaths.Count; i++)
+
+            }
+
+        </div>
+        <p style="display:none"
+           id="downloader"
+           class="text-center">
+            <br /><br /><br /><br /><br /><br /><br />
+            <i class="fa fa-cloud-download fa-spin fa-5x" id="spinner">
+            </i>
+        </p>
+        <p style="display:none"
+           id="uploader"
+           class="text-center">
+            <br /><br /><br /><br /><br /><br /><br />
+            <i class="fa fa-cloud-upload fa-spin fa-5x" id="spinner">
+            </i>
+        </p>
+        <p style="display:none"
+           id="deleter"
+           class="text-center">
+            <br /><br /><br /><br /><br /><br /><br />
+            <i class="fa fa-trash-o fa-spin fa-5x" id="spinner">
+            </i>
+        </p>
+        <div id="content">
+            @if (Model.SelectedIndex != -1)
+            {
+                <div class="col-sm-8">
+                    <h3>@Model.DisplayDatePaths[Model.SelectedIndex]</h3>
+                    <h4 style="text-align:left">Click on a file to prepare it for upload to Hive</h4>
+                    @for (int i = 0; i < Model.DisplayFilesPaths.Count; i++)
                     {
-                        <a class="btn  btn-default @(i == Model.SelectedIndex ? "active" : "" )"
-                           style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);"
-                           asp-controller="Job"
-                           asp-action="UploadDir"
-                           asp-route-index="@(i)"
-                           onclick="showDownloader()">
-                            @Model.DisplayDatePaths[i]
-                        </a>
+
+                        <div class="btn-group-justified btn-block">
+
+                            <a class="btn btn-default @(Model.DisplayFilesPaths[i].EndsWith(".hl") ? "" : "disabled" )"
+                               asp-controller="Job"
+                               asp-action="OpenFile"
+                               asp-route-index="@(Model.SelectedIndex)"
+                               asp-route-filedex="@i"
+                               style="width:6%;box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);">
+                                <i class="fa fa-list-alt"></i>  @Model.DisplayFilesPaths[i]
+                            </a>
+                            <a id="down"
+                               style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+                            text-shadow:2px 2px black;"
+                               class='btn btn-group btn-success'
+                               asp-controller="Job"
+                               asp-action="DownloadFile"
+                               asp-route-index="@(Model.SelectedIndex)"
+                               asp-route-filedex="@i">
+                                <span class='glyphicon glyphicon-download-alt' aria-hidden='true'></span>
+                            </a>
+                            <a id="del"
+                               style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+                            text-shadow:2px 2px black;"
+                               class='btn btn-group btn-danger'
+                               asp-controller="Job"
+                               asp-action="DeleteFile"
+                               asp-route-index="@(Model.SelectedIndex)"
+                               asp-route-filedex="@i"
+                               onclick="showDeleter()">
+                                <span class='glyphicon glyphicon-trash' aria-hidden='true'></span>
+                            </a>
+
+                        </div>
                     }
+                    <hr style="border-color:gray;margin-top:50px" />
+                    <form asp-controller="Job"
+                          asp-action="changeDirName" 
+                          method="post"
+                          class="col-sm-6">
+                        <h5>Change directory name</h5>
+                        <div class="input-group"
+                             style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);">
+                            <input type="text"
+                                   value="@Model.DisplayDatePaths[Model.SelectedIndex]"
+                                   style="display:none" 
+                                   name="olddir"/>
+                            <input 
+                                   name="dirname"
+                                   type="text" 
+                                   class="form-control" 
+                                   value="@Model.DisplayDatePaths[Model.SelectedIndex]" />
+                            <span class="input-group-btn">
+                                <button style="text-shadow:2px 2px black"
+                                       type="submit"
+                                       class="btn btn-success pull-right"
+                                       ><i class="fa fa-save"></i> Save</button>
+                            </span>
+                        </div>
+                    </form>
+
+
                 </div>
-                @if (ViewBag.active != null && ViewBag.active == true)
-                {
-                    <div>
-                        <a class="btn btn-warning btn-block"
-                           asp-controller="Job"
-                           asp-action="OpenRecent"
-                           style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
-                            text-shadow:2px 2px black;margin-top:10px">
-                            <i class="fa fa-undo"></i> Reopen last file
-                        </a>
-                    </div>
-
-                }
-               
-            </div>
-            <p style="display:none"
-               id="downloader"
-               class="text-center">
-                <br /><br /><br /><br /><br /><br /><br />
-                <i class="fa fa-cloud-download fa-spin fa-5x" id="spinner">
-                </i>
-            </p>
-            <p style="display:none"
-               id="uploader"
-               class="text-center">
-                <br /><br /><br /><br /><br /><br /><br />
-                <i class="fa fa-cloud-upload fa-spin fa-5x" id="spinner">
-                </i>
-            </p>
-            <p style="display:none"
-               id="deleter"
-               class="text-center">
-                <br /><br /><br /><br /><br /><br /><br />
-                <i class="fa fa-trash-o fa-spin fa-5x" id="spinner">
-                </i>
-            </p>
-            <div id="content">
-                @if (Model.SelectedIndex != -1)
-                {
-                    <div class="col-sm-8">
-                        <h4>Click on a file to prepare it for upload to Hive</h4>
-                        @for (int i = 0; i < Model.DisplayFilesPaths.Count; i++)
-                    {
-                            
-                            <div class="btn-group-justified btn-block">
-                                
-                                <a class="btn btn-default @(Model.DisplayFilesPaths[i].EndsWith(".hl") ? "" : "disabled" )"
-                                   asp-controller="Job"
-                                   asp-action="OpenFile"
-                                   asp-route-index="@(Model.SelectedIndex)"
-                                   asp-route-filedex="@i"
-                                   style="width:6%;box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);">
-                                   <i class="fa fa-list-alt"></i>  @Model.DisplayFilesPaths[i]
-                                </a>
-                                <a id="down"
-                                   style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
-                            text-shadow:2px 2px black;"
-                                   class='btn btn-group btn-success'
-                                   asp-controller="Job"
-                                   asp-action="DownloadFile"
-                                   asp-route-index="@(Model.SelectedIndex)"
-                                   asp-route-filedex="@i">
-                                    <span class='glyphicon glyphicon-download-alt' aria-hidden='true'></span>
-                                </a>
-                                <a id="del"
-                                   style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
-                            text-shadow:2px 2px black;"
-                                   class='btn btn-group btn-danger'
-                                   asp-controller="Job"
-                                   asp-action="DeleteFile"
-                                   asp-route-index="@(Model.SelectedIndex)"
-                                   asp-route-filedex="@i"
-                                   onclick="showDeleter()">
-                                    <span class='glyphicon glyphicon-trash' aria-hidden='true'></span>
-                                </a>
-                               
-                            </div>
-                        }
-
-
-                    </div>
-
-                }
-                else
-                {
-                    <div class="col-sm-8">
-
-                        @Html.Partial("UploaderPartial/_UploaderPartial")
-                    </div>
-                }
-            </div>
-
-        }
+
+            }
+            else
+            {
+                <div class="col-sm-8">
+
+                    @Html.Partial("UploaderPartial/_UploaderPartial", Model)
+                </div>
+            }
+        </div>
+
+
     </div>
     <script type="text/javascript">