Index: branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/DensityTrackbar.Designer.cs
===================================================================
--- branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/DensityTrackbar.Designer.cs	(revision 13853)
+++ branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/DensityTrackbar.Designer.cs	(revision 13855)
@@ -45,4 +45,5 @@
     /// </summary>
     private void InitializeComponent() {
+      this.components = new System.ComponentModel.Container();
       this.radioButton = new System.Windows.Forms.RadioButton();
       this.trackBar = new System.Windows.Forms.TrackBar();
@@ -51,6 +52,8 @@
       this.groupBox = new System.Windows.Forms.GroupBox();
       this.doubleLimitView = new HeuristicLab.Problems.DataAnalysis.Views.DoubleLimitView();
+      this.errorProvider = new System.Windows.Forms.ErrorProvider(this.components);
       ((System.ComponentModel.ISupportInitialize)(this.trackBar)).BeginInit();
       this.groupBox.SuspendLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.SuspendLayout();
       // 
@@ -96,7 +99,8 @@
       this.textBox.Location = new System.Drawing.Point(6, 35);
       this.textBox.Name = "textBox";
-      this.textBox.ReadOnly = true;
       this.textBox.Size = new System.Drawing.Size(132, 20);
       this.textBox.TabIndex = 4;
+      this.textBox.Validating += new System.ComponentModel.CancelEventHandler(this.textBox_Validating);
+      this.textBox.Validated += new System.EventHandler(this.textBox_Validated);
       // 
       // groupBox
@@ -125,4 +129,9 @@
       this.doubleLimitView.TabIndex = 2;
       // 
+      // errorProvider
+      // 
+      this.errorProvider.BlinkStyle = System.Windows.Forms.ErrorBlinkStyle.NeverBlink;
+      this.errorProvider.ContainerControl = this;
+      // 
       // DensityTrackbar
       // 
@@ -134,4 +143,5 @@
       this.groupBox.ResumeLayout(false);
       this.groupBox.PerformLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
       this.ResumeLayout(false);
 
@@ -146,4 +156,5 @@
     private System.Windows.Forms.TextBox textBox;
     private System.Windows.Forms.GroupBox groupBox;
+    private System.Windows.Forms.ErrorProvider errorProvider;
   }
 }
Index: branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/DensityTrackbar.cs
===================================================================
--- branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/DensityTrackbar.cs	(revision 13853)
+++ branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/DensityTrackbar.cs	(revision 13855)
@@ -22,4 +22,5 @@
 using System;
 using System.Collections.Generic;
+using System.ComponentModel;
 using System.Drawing;
 using System.Globalization;
@@ -49,9 +50,4 @@
     private IList<double> trainingValues;
 
-    // For VisualStudio Designer
-    internal DensityTrackbar() {
-      InitializeComponent();
-    }
-
     public DensityTrackbar(string name, DoubleLimit limit, IList<double> trainingValues) {
       InitializeComponent();
@@ -80,5 +76,6 @@
     #region Event Handlers
     private void trackBar_ValueChanged(object sender, EventArgs e) {
-      textBox.Text = Value.ToString(CultureInfo.InvariantCulture);
+      textBox.Text = Value.ToString(CultureInfo.CurrentUICulture);
+      textBox.Update();
       OnValueChanged();
     }
@@ -91,5 +88,6 @@
       Checked = radioButton.Checked;
       trackBar.Enabled = !Checked;
-      textBox.Text = Checked ? "Plotted" : Value.ToString(CultureInfo.InvariantCulture);
+      textBox.Enabled = !Checked;
+      textBox.Text = Checked ? "Plotted" : Value.ToString(CultureInfo.CurrentUICulture);
       radioButton.BackColor = Checked ? SystemColors.ActiveCaption : SystemColors.Control;
       OnCheckedChanged();
@@ -98,4 +96,21 @@
       base.OnTextChanged(e);
       radioButton.Text = Text;
+    }
+
+    private void textBox_Validating(object sender, CancelEventArgs e) {
+      if (Checked) return;
+      decimal number;
+      if (!decimal.TryParse(textBox.Text, NumberStyles.Any, CultureInfo.CurrentUICulture.NumberFormat, out number)) {
+        e.Cancel = true;
+        errorProvider.SetIconAlignment(textBox, ErrorIconAlignment.MiddleLeft);
+        errorProvider.SetIconPadding(textBox, 2);
+        errorProvider.SetError(textBox, "Illegal number format");
+      }
+    }
+
+    private void textBox_Validated(object sender, EventArgs e) {
+      if (Checked) return;
+      errorProvider.SetError(textBox, string.Empty);
+      Value = decimal.Parse(textBox.Text, NumberStyles.Any, CultureInfo.CurrentUICulture.NumberFormat);
     }
     #endregion
Index: branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/GradientChart.Designer.cs
===================================================================
--- branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/GradientChart.Designer.cs	(revision 13853)
+++ branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/GradientChart.Designer.cs	(revision 13855)
@@ -25,4 +25,5 @@
     private void InitializeComponent() {
       this.components = new System.ComponentModel.Container();
+      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(GradientChart));
       System.Windows.Forms.DataVisualization.Charting.VerticalLineAnnotation verticalLineAnnotation1 = new System.Windows.Forms.DataVisualization.Charting.VerticalLineAnnotation();
       System.Windows.Forms.DataVisualization.Charting.ChartArea chartArea1 = new System.Windows.Forms.DataVisualization.Charting.ChartArea();
@@ -33,4 +34,6 @@
       this.calculationPendingTimer = new System.Windows.Forms.Timer(this.components);
       this.chart = new HeuristicLab.Visualization.ChartControlsExtensions.EnhancedChart();
+      this.configurationButton = new System.Windows.Forms.Button();
+      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
       ((System.ComponentModel.ISupportInitialize)(this.chart)).BeginInit();
       this.SuspendLayout();
@@ -90,8 +93,23 @@
       this.chart.MouseMove += new System.Windows.Forms.MouseEventHandler(this.chart_MouseMove);
       // 
+      // configurationButton
+      // 
+      this.configurationButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.configurationButton.AutoSize = true;
+      this.configurationButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Properties;
+      this.configurationButton.Location = new System.Drawing.Point(426, 3);
+      this.configurationButton.Name = "configurationButton";
+      this.configurationButton.Size = new System.Drawing.Size(24, 24);
+      this.configurationButton.TabIndex = 2;
+      this.configurationButton.TabStop = false;
+      this.toolTip.SetToolTip(this.configurationButton, "Configuration");
+      this.configurationButton.UseVisualStyleBackColor = true;
+      this.configurationButton.Click += new System.EventHandler(this.config_Click);
+      // 
       // GradientChart
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.configurationButton);
       this.Controls.Add(this.calculationPendingLabel);
       this.Controls.Add(this.chart);
@@ -100,4 +118,5 @@
       ((System.ComponentModel.ISupportInitialize)(this.chart)).EndInit();
       this.ResumeLayout(false);
+      this.PerformLayout();
 
     }
@@ -108,4 +127,6 @@
     private System.Windows.Forms.Label calculationPendingLabel;
     private System.Windows.Forms.Timer calculationPendingTimer;
+    private System.Windows.Forms.Button configurationButton;
+    private System.Windows.Forms.ToolTip toolTip;
   }
 }
Index: branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/GradientChart.cs
===================================================================
--- branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/GradientChart.cs	(revision 13853)
+++ branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/GradientChart.cs	(revision 13855)
@@ -60,4 +60,9 @@
     }
 
+    public bool ShowConfigButton {
+      get { return configurationButton.Visible; }
+      set { configurationButton.Visible = value; }
+    }
+
     private int xAxisTicks = 5;
     public int XAxisTicks {
@@ -190,5 +195,5 @@
 
       configToolStripMenuItem = new ToolStripMenuItem("Configuration");
-      configToolStripMenuItem.Click += configToolStripMenuItem_Click;
+      configToolStripMenuItem.Click += config_Click;
       chart.ContextMenuStrip.Items.Add(new ToolStripSeparator());
       chart.ContextMenuStrip.Items.Add(configToolStripMenuItem);
@@ -596,5 +601,5 @@
     }
 
-    private void configToolStripMenuItem_Click(object sender, EventArgs e) {
+    private void config_Click(object sender, EventArgs e) {
       configurationDialog.ShowDialog(this);
     }
Index: branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/GradientChartConfigurationDialog.Designer.cs
===================================================================
--- branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/GradientChartConfigurationDialog.Designer.cs	(revision 13853)
+++ branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/GradientChartConfigurationDialog.Designer.cs	(revision 13855)
@@ -45,6 +45,8 @@
     /// </summary>
     private void InitializeComponent() {
+      this.components = new System.ComponentModel.Container();
       this.xAxisGroupBox = new System.Windows.Forms.GroupBox();
       this.maxXTextBox = new System.Windows.Forms.TextBox();
+      this.xAutomaticCheckBox = new System.Windows.Forms.CheckBox();
       this.minXTextBox = new System.Windows.Forms.TextBox();
       this.maxXLabel = new System.Windows.Forms.Label();
@@ -57,13 +59,14 @@
       this.minYLabel = new System.Windows.Forms.Label();
       this.miscGroupBox = new System.Windows.Forms.GroupBox();
+      this.StepsNumericUpDown = new System.Windows.Forms.NumericUpDown();
       this.stepsLabel = new System.Windows.Forms.Label();
       this.applyButton = new System.Windows.Forms.Button();
       this.cancelButton = new System.Windows.Forms.Button();
-      this.xAutomaticCheckBox = new System.Windows.Forms.CheckBox();
-      this.StepsNumericUpDown = new System.Windows.Forms.NumericUpDown();
+      this.errorProvider = new System.Windows.Forms.ErrorProvider(this.components);
       this.xAxisGroupBox.SuspendLayout();
       this.yAxisGroupBox.SuspendLayout();
       this.miscGroupBox.SuspendLayout();
       ((System.ComponentModel.ISupportInitialize)(this.StepsNumericUpDown)).BeginInit();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.SuspendLayout();
       // 
@@ -92,4 +95,17 @@
       this.maxXTextBox.Size = new System.Drawing.Size(167, 20);
       this.maxXTextBox.TabIndex = 3;
+      this.maxXTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.numberTextBox_Validating);
+      this.maxXTextBox.Validated += new System.EventHandler(this.numberTextBox_Validated);
+      // 
+      // xAutomaticCheckBox
+      // 
+      this.xAutomaticCheckBox.AutoSize = true;
+      this.xAutomaticCheckBox.Location = new System.Drawing.Point(48, -1);
+      this.xAutomaticCheckBox.Name = "xAutomaticCheckBox";
+      this.xAutomaticCheckBox.Size = new System.Drawing.Size(73, 17);
+      this.xAutomaticCheckBox.TabIndex = 1;
+      this.xAutomaticCheckBox.Text = "Automatic";
+      this.xAutomaticCheckBox.UseVisualStyleBackColor = true;
+      this.xAutomaticCheckBox.CheckedChanged += new System.EventHandler(this.automaticCheckBox_CheckedChanged);
       // 
       // minXTextBox
@@ -101,4 +117,6 @@
       this.minXTextBox.Size = new System.Drawing.Size(167, 20);
       this.minXTextBox.TabIndex = 2;
+      this.minXTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.numberTextBox_Validating);
+      this.minXTextBox.Validated += new System.EventHandler(this.numberTextBox_Validated);
       // 
       // maxXLabel
@@ -144,4 +162,6 @@
       this.maxYTextBox.Size = new System.Drawing.Size(167, 20);
       this.maxYTextBox.TabIndex = 3;
+      this.maxYTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.numberTextBox_Validating);
+      this.maxYTextBox.Validated += new System.EventHandler(this.numberTextBox_Validated);
       // 
       // yAutomaticCheckBox
@@ -164,4 +184,6 @@
       this.minYTextBox.Size = new System.Drawing.Size(167, 20);
       this.minYTextBox.TabIndex = 2;
+      this.minYTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.numberTextBox_Validating);
+      this.minYTextBox.Validated += new System.EventHandler(this.numberTextBox_Validated);
       // 
       // maxYLabel
@@ -194,46 +216,4 @@
       this.miscGroupBox.TabIndex = 4;
       this.miscGroupBox.TabStop = false;
-      // 
-      // stepsLabel
-      // 
-      this.stepsLabel.AutoSize = true;
-      this.stepsLabel.Location = new System.Drawing.Point(6, 22);
-      this.stepsLabel.Name = "stepsLabel";
-      this.stepsLabel.Size = new System.Drawing.Size(34, 13);
-      this.stepsLabel.TabIndex = 1;
-      this.stepsLabel.Text = "Steps";
-      // 
-      // applyButton
-      // 
-      this.applyButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
-      this.applyButton.Location = new System.Drawing.Point(91, 239);
-      this.applyButton.Name = "applyButton";
-      this.applyButton.Size = new System.Drawing.Size(75, 23);
-      this.applyButton.TabIndex = 5;
-      this.applyButton.Text = "Apply";
-      this.applyButton.UseVisualStyleBackColor = true;
-      this.applyButton.Click += new System.EventHandler(this.okButton_Click);
-      // 
-      // cancelButton
-      // 
-      this.cancelButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
-      this.cancelButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
-      this.cancelButton.Location = new System.Drawing.Point(172, 239);
-      this.cancelButton.Name = "cancelButton";
-      this.cancelButton.Size = new System.Drawing.Size(75, 23);
-      this.cancelButton.TabIndex = 6;
-      this.cancelButton.Text = "Cancel";
-      this.cancelButton.UseVisualStyleBackColor = true;
-      // 
-      // xAutomaticCheckBox
-      // 
-      this.xAutomaticCheckBox.AutoSize = true;
-      this.xAutomaticCheckBox.Location = new System.Drawing.Point(48, -1);
-      this.xAutomaticCheckBox.Name = "xAutomaticCheckBox";
-      this.xAutomaticCheckBox.Size = new System.Drawing.Size(73, 17);
-      this.xAutomaticCheckBox.TabIndex = 1;
-      this.xAutomaticCheckBox.Text = "Automatic";
-      this.xAutomaticCheckBox.UseVisualStyleBackColor = true;
-      this.xAutomaticCheckBox.CheckedChanged += new System.EventHandler(this.automaticCheckBox_CheckedChanged);
       // 
       // StepsNumericUpDown
@@ -255,4 +235,40 @@
       this.StepsNumericUpDown.Size = new System.Drawing.Size(166, 20);
       this.StepsNumericUpDown.TabIndex = 4;
+      // 
+      // stepsLabel
+      // 
+      this.stepsLabel.AutoSize = true;
+      this.stepsLabel.Location = new System.Drawing.Point(6, 22);
+      this.stepsLabel.Name = "stepsLabel";
+      this.stepsLabel.Size = new System.Drawing.Size(34, 13);
+      this.stepsLabel.TabIndex = 1;
+      this.stepsLabel.Text = "Steps";
+      // 
+      // applyButton
+      // 
+      this.applyButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.applyButton.Location = new System.Drawing.Point(91, 239);
+      this.applyButton.Name = "applyButton";
+      this.applyButton.Size = new System.Drawing.Size(75, 23);
+      this.applyButton.TabIndex = 5;
+      this.applyButton.Text = "Apply";
+      this.applyButton.UseVisualStyleBackColor = true;
+      this.applyButton.Click += new System.EventHandler(this.okButton_Click);
+      // 
+      // cancelButton
+      // 
+      this.cancelButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.cancelButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
+      this.cancelButton.Location = new System.Drawing.Point(172, 239);
+      this.cancelButton.Name = "cancelButton";
+      this.cancelButton.Size = new System.Drawing.Size(75, 23);
+      this.cancelButton.TabIndex = 6;
+      this.cancelButton.Text = "Cancel";
+      this.cancelButton.UseVisualStyleBackColor = true;
+      // 
+      // errorProvider
+      // 
+      this.errorProvider.BlinkStyle = System.Windows.Forms.ErrorBlinkStyle.NeverBlink;
+      this.errorProvider.ContainerControl = this;
       // 
       // GradientChartConfigurationDialog
@@ -279,4 +295,5 @@
       this.miscGroupBox.PerformLayout();
       ((System.ComponentModel.ISupportInitialize)(this.StepsNumericUpDown)).EndInit();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
       this.ResumeLayout(false);
 
@@ -302,4 +319,5 @@
     private System.Windows.Forms.CheckBox xAutomaticCheckBox;
     private System.Windows.Forms.NumericUpDown StepsNumericUpDown;
+    private System.Windows.Forms.ErrorProvider errorProvider;
   }
 }
Index: branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/GradientChartConfigurationDialog.cs
===================================================================
--- branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/GradientChartConfigurationDialog.cs	(revision 13853)
+++ branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/GradientChartConfigurationDialog.cs	(revision 13855)
@@ -21,4 +21,5 @@
 
 using System;
+using System.ComponentModel;
 using System.Globalization;
 using System.Windows.Forms;
@@ -28,8 +29,4 @@
   public partial class GradientChartConfigurationDialog : Form {
     private readonly GradientChart chart;
-
-    private IFormatProvider FormatProvider {
-      get { return CultureInfo.CurrentUICulture.NumberFormat; }
-    }
 
     public GradientChartConfigurationDialog(GradientChart chart) {
@@ -41,11 +38,11 @@
       if (chart.FixedXAxisMin.HasValue && chart.FixedXAxisMax.HasValue) {
         xAutomaticCheckBox.Checked = false;
-        minXTextBox.Text = chart.FixedXAxisMin.Value.ToString(FormatProvider);
-        maxXTextBox.Text = chart.FixedXAxisMax.Value.ToString(FormatProvider);
+        minXTextBox.Text = chart.FixedXAxisMin.Value.ToString(CultureInfo.CurrentUICulture);
+        maxXTextBox.Text = chart.FixedXAxisMax.Value.ToString(CultureInfo.CurrentUICulture);
       } else xAutomaticCheckBox.Checked = true;
       if (chart.FixedYAxisMin.HasValue && chart.FixedYAxisMax.HasValue) {
         yAutomaticCheckBox.Checked = false;
-        minYTextBox.Text = chart.FixedYAxisMin.Value.ToString(FormatProvider);
-        maxYTextBox.Text = chart.FixedYAxisMax.Value.ToString(FormatProvider);
+        minYTextBox.Text = chart.FixedYAxisMin.Value.ToString(CultureInfo.CurrentUICulture);
+        maxYTextBox.Text = chart.FixedYAxisMax.Value.ToString(CultureInfo.CurrentUICulture);
       } else yAutomaticCheckBox.Checked = true;
       StepsNumericUpDown.Value = chart.DrawingSteps;
@@ -59,6 +56,6 @@
           chart.FixedXAxisMax = null;
         } else {
-          var min = Convert.ToDouble(minXTextBox.Text, FormatProvider);
-          var max = Convert.ToDouble(maxXTextBox.Text, FormatProvider);
+          var min = double.Parse(minXTextBox.Text, CultureInfo.CurrentUICulture);
+          var max = double.Parse(maxXTextBox.Text, CultureInfo.CurrentUICulture);
           chart.FixedXAxisMin = min;
           chart.FixedXAxisMax = max;
@@ -69,6 +66,6 @@
           chart.FixedYAxisMax = null;
         } else {
-          var min = Convert.ToDouble(minYTextBox.Text, FormatProvider);
-          var max = Convert.ToDouble(maxYTextBox.Text, FormatProvider);
+          var min = double.Parse(minYTextBox.Text, CultureInfo.CurrentUICulture);
+          var max = double.Parse(maxYTextBox.Text, CultureInfo.CurrentUICulture);
           chart.FixedYAxisMin = min;
           chart.FixedYAxisMax = max;
@@ -81,6 +78,6 @@
         Close();
       }
-      catch (FormatException fe) {
-        MessageBox.Show(this, "Illegal number format: {0}", fe.Message, MessageBoxButtons.OK, MessageBoxIcon.Error);
+      catch (FormatException) {
+        MessageBox.Show(this, "Illegal number format", "Wrong format", MessageBoxButtons.OK, MessageBoxIcon.Error);
       }
       finally {
@@ -96,4 +93,27 @@
       maxYTextBox.Enabled = !yAutomaticCheckBox.Checked;
     }
+
+    private void numberTextBox_Validating(object sender, CancelEventArgs e) {
+      var textBox = sender as TextBox;
+      if (textBox != null) {
+        double number;
+        if (!double.TryParse(textBox.Text, NumberStyles.Any, CultureInfo.CurrentUICulture, out number)) {
+          e.Cancel = true;
+          applyButton.Enabled = false;
+          errorProvider.SetIconAlignment(textBox, ErrorIconAlignment.MiddleLeft);
+          errorProvider.SetIconPadding(textBox, 2);
+          errorProvider.SetError(textBox, "Illegal number format");
+          textBox.SelectAll();
+        }
+      }
+    }
+
+    private void numberTextBox_Validated(object sender, EventArgs e) {
+      var textBox = sender as TextBox;
+      if (textBox != null) {
+        errorProvider.SetError(textBox, string.Empty);
+        applyButton.Enabled = true;
+      }
+    }
   }
 }
Index: branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionTargetResponseGradientView.cs
===================================================================
--- branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionTargetResponseGradientView.cs	(revision 13853)
+++ branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionTargetResponseGradientView.cs	(revision 13855)
@@ -126,6 +126,4 @@
 
         var densityChart = new DensityChart() {
-          //Dock = DockStyle.Top,
-          //Location = new Point(0, 0),
           Anchor = AnchorStyles.Left | AnchorStyles.Top | AnchorStyles.Right,
           Margin = Padding.Empty,
@@ -160,4 +158,5 @@
         ShowLegend = false,
         ShowCursor = true,
+        ShowConfigButton = false,
         YAxisTicks = 5,
       };